mod Ex03a

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  3. CVIČENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.20 
  \para* \it  Dátum:  \end streda 8.10.2014 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/1415zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované základnému 
  vývoju primitívne rekurzívnych funkcií (explicitné a primitívne 
  rekurzívne definície). Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 13.10.2014 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/3 Tex_f3_rec_c_3_2
  Prefix(90,2,Subsup(Id(0,'C',0),75,Num('2',0),Num('3',0)),
         Fenced(Op('(',0),
                Infix(Arg(0),30,2,Op(',',0),Infix(Arg(1),30,2,Op(',',0),Arg(2))),
                Op(')',0)))

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Explicit Definitions.  \end 

rem 
  \para \bf  Subsection. Constant Functions.  \end 

rem 
  \para \bf  Exercise.  \end Find a p.r. derivation of the following unary 
  constant functions 
  \eq* 
    C1(x) = 1
  \end
  \eq* 
    C2(x) = 2
  \end

fun C1 
  C1(x) = Foo

fun C2 
  C2(x) = Foo

rem 
  \para \bf  Theorem.  \end Unary constant functions are primitive recursive. 

rem 
  \para \bf  Exercise.  \end Find a p.r. derivation of the following ternary 
  constant function 
  \eq* 
    Tex_f3_rec_c_3_2(x1,x2,x3) = 2
  \end

fun/3 C_3_2 'Tex_f3_rec_c_3_2'
  C_3_2(x1,x2,x3) = Foo

rem 
  \para \bf  Theorem.  \end Constant functions are primitive recursive. 

rem 
  \para \bf  Subsection. Explicit Definitions of Functions.  \end 

theory Rearrangement

rem 
  \para \bf  Exercise.  \end 

fun/2 G 'Tex_f2_g'

rem 
  \para Show that if \ft Tex_f0_g \end is a p.r. function then so is the 
  function \ft Tex_f0_f \end defined by 

fun/2 F 'Tex_f2_f'
  F(x,y) = G(y,x)

rem 
  \para \it  Proof.  \end 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Rearrangement

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _r  \end. 

theory Identification

rem 
  \para \bf  Exercise.  \end 

fun/2 G 'Tex_f2_g'

rem 
  \para Show that if \ft Tex_f0_g \end is a p.r. function then so is the 
  function \ft Tex_f0_f \end defined by 

fun F 'Tex_f1_f'
  F(x) = G(x,x)

rem 
  \para \it  Proof.  \end 

fun F_is_primrec 'Tex_f1_f'
  F_is_primrec(x) = Foo

end theory Identification

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _i  \end. 

theory Adding_dummy_variables

rem 
  \para \bf  Exercise.  \end 

fun G 'Tex_f1_g'

rem 
  \para Show that if \ft Tex_f0_g \end is a p.r. function then so is the 
  function \ft Tex_f0_f \end defined by 

fun/2 F 'Tex_f2_f'
  F(x,y) = G(x)

rem 
  \para \it  Proof.  \end 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Adding_dummy_variables

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _d  \end. 

theory Constants

rem 
  \para \bf  Exercise.  \end 

fun G 'Tex_f1_g'

rem 
  \para Show that if \ft Tex_f0_g \end is a p.r. function then so is the 
  function \ft Tex_f0_f \end defined by 

fun F 'Tex_f1_f'
  F(x) = G(2)

rem 
  \para \it  Proof.  \end 

fun F_is_primrec 'Tex_f1_f'
  F_is_primrec(x) = Foo

end theory Constants

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _c  \end. 

theory Nested_composition

rem 
  \para \bf  Exercise.  \end 

fun G1 

fun G2 

fun G3 

rem 
  \para Show that if \ft G1 \end, \ft G2 \end and \ft G3 \end are p.r. functions 
  then so is the function \ft Tex_f0_f \end defined by 

fun F 'Tex_f1_f'
  F(x) = G1 G2 G3(x)

rem 
  \para \it  Proof.  \end 

fun F_is_primrec 'Tex_f1_f'
  F_is_primrec(x) = Foo

end theory Nested_composition

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _n  \end. 

theory Explicit_definition

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 

fun G1 

fun/2 G2 

fun/3 G3 

rem 
  \para Show that if \ft G1 \end, \ft G2 \end and \ft G3 \end are p.r. functions 
  then so is the ternary function \ft Tex_f0_f \end defined by 

fun/3 F 'Tex_f3_f'
  F(x,y,z) = G3(x,G2(z,G1(x)),2)

rem 
  \para \it  Proof.  \end 

fun/3 F_is_primrec 'Tex_f3_f'
  F_is_primrec(x,y,z) = Foo

end theory Explicit_definition

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _e  \end. 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  explicit definitions. 

rem 
  \para \bf  Exercise.  \end Show that the addition function \ft x+y \end is 
  primitive recursive. 

fun/2 Plus 'Tex_f2_n_plus'
  Plus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x+y \end. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

